## pidgin-whatsapp 0.9.0mx150+1

=== Makefile ===

LIBNAME = libwhatsapp.so
ARCH = ""

ifeq ($(ARCH),i686)
	ARCHFLAGS = -m32
else ifeq ($(ARCH),x86_64)
	ARCHFLAGS = -m64
else
	ARCHFLAGS = 
endif

.PHONY: all
all: $(LIBNAME)

INCLUDES = -I./libaxolotl-cpp/ecc \
           -I./libaxolotl-cpp/exception \
           -I./libaxolotl-cpp/util \
           -I./libaxolotl-cpp/state \
           -I./libaxolotl-cpp/protocol \
           -I./libaxolotl-cpp/groups/ratchet \
           -I./libaxolotl-cpp/groups/state \
           -I./libaxolotl-cpp/groups \
           -I./libaxolotl-cpp/kdf \
           -I./libaxolotl-cpp/ratchet \
           -I./libaxolotl-cpp/mem-store \
           -I./libaxolotl-cpp

#           -I./libaxolotl-cpp/sqli-store \

C_SRCS = tinfl.c imgutil.c aes.c
CXX_SRCS = whatsapp-protocol.cc wa_util.cc rc4.cc keygen.cc tree.cc databuffer.cc message.cc wa_purple.cc

C_OBJS = $(C_SRCS:.c=.o)
CXX_OBJS = $(CXX_SRCS:.cc=.o) AxolotlMessages.pb.o

PKG_CONFIG = pkg-config
STRIP = strip
CC = gcc
CXX = g++
LD = $(CXX)
CFLAGS_PURPLE = $(shell $(PKG_CONFIG) --cflags purple)
CFLAGS ?= \
    $(ARCHFLAGS) \
    -O2 \
    -Wall \
    -Wno-unused-function
CFLAGS += \
    -fPIC \
    -DPURPLE_PLUGINS \
    -DPIC \
    $(INCLUDES) \
    $(CFLAGS_PURPLE)

CXXFLAGS += -std=c++11

LIBS_PURPLE = $(shell $(PKG_CONFIG) --libs purple) -lfreeimage ./libaxolotl-cpp/libaxolotl.a -lprotobuf ./libaxolotl-cpp/libcurve25519/libcurve25519.a
LDFLAGS ?= $(ARCHFLAGS)
LDFLAGS += -shared -pipe

libaxolotl-cpp/libcurve25519/libcurve25519.a:
	+make -C libaxolotl-cpp/libcurve25519

libaxolotl-cpp/libaxolotl.a:	libaxolotl-cpp/libcurve25519/libcurve25519.a
	+make -C libaxolotl-cpp

AxolotlMessages.pb.h:	AxolotlMessages.proto
	protoc --cpp_out=. AxolotlMessages.proto
AxolotlMessages.pb.cc:	AxolotlMessages.pb.h
	# Do nothing

%.o: %.c libaxolotl-cpp/libaxolotl.a
	$(CC) -c $(CFLAGS) -std=c99 -o $@ $<
%.o: %.cc AxolotlMessages.pb.h libaxolotl-cpp/libaxolotl.a
	$(CXX) -c $(CFLAGS) $(CXXFLAGS) -o $@ $<

$(LIBNAME): $(C_OBJS) $(CXX_OBJS) 
	$(LD) $(LDFLAGS) -o $@ $^ $(LIBS_PURPLE)

.PHONY: strip
strip: $(LIBNAME)
	$(STRIP) --strip-unneeded $(LIBNAME)

.PHONY: debug
debug:
	+ CFLAGS="$$CFLAGS -DDEBUG -g3 -O0" make all

PLUGIN_DIR_PURPLE:=$(shell $(PKG_CONFIG) --variable=plugindir purple)
DATA_ROOT_DIR_PURPLE:=$(shell $(PKG_CONFIG) --variable=datarootdir purple)

.PHONY: install
install: $(LIBNAME)
	install -D $(LIBNAME) $(DESTDIR)$(PLUGIN_DIR_PURPLE)/$(LIBNAME)
	install -D -m 644 whatsapp16.png $(DESTDIR)$(DATA_ROOT_DIR_PURPLE)/pixmaps/pidgin/protocols/16/whatsapp.png
	install -D -m 644 whatsapp22.png $(DESTDIR)$(DATA_ROOT_DIR_PURPLE)/pixmaps/pidgin/protocols/22/whatsapp.png
	install -D -m 644 whatsapp48.png $(DESTDIR)$(DATA_ROOT_DIR_PURPLE)/pixmaps/pidgin/protocols/48/whatsapp.png

.PHONY: uninstall
uninstall: $(LIBNAME)
	rm -f $(DESTDIR)$(PLUGIN_DIR_PURPLE)/$(LIBNAME)
	rm -f $(DESTDIR)$(DATA_ROOT_DIR_PURPLE)/pixmaps/pidgin/protocols/16/whatsapp.png
	rm -f $(DESTDIR)$(DATA_ROOT_DIR_PURPLE)/pixmaps/pidgin/protocols/22/whatsapp.png
	rm -f $(DESTDIR)$(DATA_ROOT_DIR_PURPLE)/pixmaps/pidgin/protocols/48/whatsapp.png

.PHONY: clean
clean:
	-rm -f AxolotlMessages.pb.cc AxolotlMessages.pb.h
	-rm -f *.o
	-rm -f $(LIBNAME)

.PHONY: cleanall
cleanall:	clean
	make -C libaxolotl-cpp clean
	make -C libaxolotl-cpp/libcurve25519/ clean

=== libaxolotl-cpp/Makefile ===

CXX=g++
GCC=gcc

CFLAGS = -I./ecc -I./exception -I./util -I./state -I./groups/ratchet -I./groups/state -I./kdf -I./ratchet -I./protocol -I./ -std=c++11 -O2 -fPIC $(EXTRA_INCLUDES)

CPP_FILES = identitykey.cpp \
			identitykeypair.cpp \
			sessionbuilder.cpp \
			sessioncipher.cpp \
			ecc/curve.cpp \
			ecc/eckeypair.cpp \
			ecc/djbec.cpp \
			kdf/derivedmessagesecrets.cpp \
			kdf/derivedrootsecrets.cpp \
			kdf/hkdf.cpp \
			groups/group_session_builder.cpp \
			groups/state/senderkeystate.cpp \
			groups/state/senderkeyrecord.cpp \
			groups/ratchet/senderchainkey.cpp \
			groups/ratchet/sendermessagekey.cpp \
			ratchet/bobaxolotlparameters.cpp \
			ratchet/aliceaxolotlparameters.cpp \
			ratchet/messagekeys.cpp \
			ratchet/ratchetingsession.cpp \
			ratchet/chainkey.cpp \
			ratchet/rootkey.cpp \
			ratchet/symmetricaxolotlparameters.cpp \
			state/signedprekeyrecord.cpp \
			state/prekeybundle.cpp \
			state/prekeyrecord.cpp \
			state/sessionrecord.cpp \
			state/sessionstate.cpp \
			util/byteutil.cpp \
			util/keyhelper.cpp \
			protocol/keyexchangemessage.cpp \
			protocol/senderkeydistributionmessage.cpp \
			protocol/whispermessage.cpp \
			protocol/prekeywhispermessage.cpp \
			protocol/senderkeymessage.cpp \
			protocol/ciphertextmessage.cpp \
			mem-store/inmemoryaxolotlstore.cpp \
			mem-store/inmemoryidentitykeystore.cpp \
			mem-store/inmemoryprekeystore.cpp \
			mem-store/inmemorysignedprekeystore.cpp \
			mem-store/inmemorysessionstore.cpp \
			mem-store/inmemorysenderkeystore.cpp \
			mem-store/serializer.cpp \
			state/LocalStorageProtocol.pb.cc \
			protocol/WhisperTextProtocol.pb.cc

HEADERS = state/LocalStorageProtocol.pb.h protocol/WhisperTextProtocol.pb.h

OBJS1 = $(CPP_FILES:%.cpp=%.o)
OBJS =  $(OBJS1:%.cc=%.o)

all:	$(HEADERS) $(OBJS)
	$(AR) rcs libaxolotl.a $(OBJS)

protocol/WhisperTextProtocol.pb.cc:	protocol/WhisperTextProtocol.pb.h
	# Do nothing

state/LocalStorageProtocol.pb.cc:	state/LocalStorageProtocol.pb.h
	# Do nothing

protocol/WhisperTextProtocol.pb.h:
	protoc --cpp_out=protocol protobuf/WhisperTextProtocol.proto
	cp protocol/protobuf/WhisperTextProtocol.pb.cc protocol/WhisperTextProtocol.pb.cc
	cp protocol/protobuf/WhisperTextProtocol.pb.h protocol/WhisperTextProtocol.pb.h

state/LocalStorageProtocol.pb.h:
	protoc --cpp_out=state protobuf/LocalStorageProtocol.proto
	cp state/protobuf/LocalStorageProtocol.pb.cc state/LocalStorageProtocol.pb.cc
	cp state/protobuf/LocalStorageProtocol.pb.h state/LocalStorageProtocol.pb.h

%.o:	%.cpp
	$(CXX) -o $@ -c $< $(CFLAGS)

%.o:	%.cc
	$(CXX) -o $@ -c $< $(CFLAGS)

clean:
	rm -f libaxolotl.a libaxolotl.so $(OBJS) state/LocalStorageProtocol.pb.cc protocol/WhisperTextProtocol.pb.cc state/LocalStorageProtocol.pb.h protocol/WhisperTextProtocol.pb.h

=== libaxolotl-cpp/libcurve25519/Makefile ===

CC=gcc
CXX=g++
AR=ar

TARGET=libcurve25519.a
INCLUDES=-I./src/ed25519/ -I./src/ed25519/additions/ -I./src/ed25519/nacl_includes/
CFLAGS=-DLIBCURVE25519_LIBRARY -O2 -fPIC 

HEADERS=curve.h curve_global.h
#    src/ed25519/main/main.c

CXXSOURCES = curve.cpp

SOURCES += \
    src/curve25519-donna.c \
    src/ed25519/fe_neg.c \
    src/ed25519/ge_p1p1_to_p2.c \
    src/ed25519/fe_cmov.c \
    src/ed25519/ge_p3_dbl.c \
    src/ed25519/ge_p3_0.c \
    src/ed25519/fe_pow22523.c \
    src/ed25519/fe_copy.c \
    src/ed25519/ge_msub.c \
    src/ed25519/fe_1.c \
    src/ed25519/fe_frombytes.c \
    src/ed25519/ge_sub.c \
    src/ed25519/ge_tobytes.c \
    src/ed25519/ge_add.c \
    src/ed25519/open.c \
    src/ed25519/ge_p1p1_to_p3.c \
    src/ed25519/fe_invert.c \
    src/ed25519/fe_add.c \
    src/ed25519/fe_mul.c \
    src/ed25519/sc_muladd.c \
    src/ed25519/ge_frombytes.c \
    src/ed25519/fe_sub.c \
    src/ed25519/ge_p3_to_cached.c \
    src/ed25519/ge_p2_dbl.c \
    src/ed25519/ge_scalarmult_base.c \
    src/ed25519/ge_madd.c \
    src/ed25519/fe_sq2.c \
    src/ed25519/additions/sign_modified.c \
    src/ed25519/additions/zeroize.c \
    src/ed25519/additions/compare.c \
    src/ed25519/additions/curve_sigs.c \
    src/ed25519/fe_tobytes.c \
    src/ed25519/ge_precomp_0.c \
    src/ed25519/fe_isnonzero.c \
    src/ed25519/ge_p2_0.c \
    src/ed25519/fe_isnegative.c \
    src/ed25519/nacl_sha512/blocks.c \
    src/ed25519/nacl_sha512/hash.c \
    src/ed25519/fe_0.c \
    src/ed25519/ge_p3_tobytes.c \
    src/ed25519/sign.c \
    src/ed25519/ge_double_scalarmult.c \
    src/ed25519/sc_reduce.c \
    src/ed25519/ge_p3_to_p2.c \
    src/ed25519/fe_sq.c

COBJS = $(SOURCES:%.c=%.o)
CXXOBJS = $(CXXSOURCES:%.cpp=%.o)

%.o:	%.c
	$(CC) -o $@ -c $< $(CFLAGS) -std=c99 

%.o:	%.cpp
	$(CXX) -o $@ -c $< $(CFLAGS)

all:	$(COBJS) $(CXXOBJS)
	$(AR) rcs $(TARGET) $(COBJS) $(CXXOBJS)

clean:
	rm -f $(TARGET) $(COBJS) $(CXXOBJS)

=== debian/changelog ===
pidgin-whatsapp (0.9.0mx150+1) mx; urgency=medium

  * Repackaged for MX-15

 -- Timothy E. Harris <maintainer@mepiscommunity.org>  Thu, 11 Feb 2016 13:22:14 -0500

pidgin-whatsapp (0.9.0) trusty; urgency=low

  * Implemented axolotl encryption
  * Added libprotobuf as a dependency
  * Implemented most decryption schemes, even for groups
  * Message sending only working for plaintext messages
  * Implemented WA1.6 network protocol
  * This is very WIP and unstable, many bugs will probably show up

 -- David Guillen Fandos <david@davidgf.net>  Thu, 29 Jan 2016 00:45:00 +0100

pidgin-whatsapp (0.8.6) trusty; urgency=low

  * Some cleanup for smaller binary size
  * Potentially fixed some crashes
  * Fixed "last seen" timestamp

 -- David Guillen Fandos <david@davidgf.net>  Thu, 21 Jul 2015 23:00:00 +0100

pidgin-whatsapp (0.8.5) trusty; urgency=low

  * Update default WhatsApp client version

 -- David Guillen Fandos <david@davidgf.net>  Thu, 21 Jul 2015 23:00:00 +0100

pidgin-whatsapp (0.8.4) trusty; urgency=low

  * Fixed a bug (segfault) introduced in 0.8.3

 -- David Guillen Fandos <david@davidgf.net>  Thu, 1 Jul 2015 18:25:00 +0100

pidgin-whatsapp (0.8.3) trusty; urgency=low

  * Changed some protocol stuff to behave like Android.
  * Fixed some minor issues with groups.
  * Implemented new groups (v2). Should fix group compatibility problems.
  * Some fixes on VCard reception

 -- David Guillen Fandos <david@davidgf.net>  Thu, 25 Jun 2015 22:47:00 +0200

pidgin-whatsapp (0.8.2) trusty; urgency=low

  * Fixed a bug which prevented messages from being received in a random fashion

 -- David Guillen Fandos <david@davidgf.net>  Wed, 6 May 2015 20:45:00 +0100

pidgin-whatsapp (0.8.1) trusty; urgency=low

  * Added ability to detect incoming voice calls
  * Fixed some bugs which cause the connection to drop (keepalive)

 -- David Guillen Fandos <david@davidgf.net>  Wed, 22 Apr 2015 19:45:00 +0100

pidgin-whatsapp (0.8) trusty; urgency=low

  * Ability to change profile picture
  * Ability to set privacy options
  * Fixed image sending by creating realistic thumbnails
  * Fixed profile picture update for contacts in buddy list
  * Fixing some features to look like an android phone
  * Supports receiving broadcast messages
  * Fixed some minor bugs with groups and some cleanup
  * Fixed some leaks (probably some still ther)
  * Fixing status message setting
  * Fixed photo thumbnails display when receiving media messages

 -- David Guillen Fandos <david@davidgf.net>  Sun, 22 Mar 2015 23:23:00 +0100

pidgin-whatsapp (0.7) trusty; urgency=low

  * Minor fixes on whatsapp API interaction
  * Many clean up and windows refactor
  * Added support for protocol version 1.5
  * Fix bug with GPS localization receive and send (float parsing)

 -- David Guillen Fandos <david@davidgf.net>  Tue, 27 Jan 2015 00:45:00 +0100

pidgin-whatsapp (0.6) trusty; urgency=low

  * Minor fixes on groups support
  * Changed some default values to get better compatibility
  * Implemented mesage read (blue tick) support
  * Fixed some upload issues (usually hangs during upload)
  * Added support for plugins to display sent message reception

 -- David Guillen Fandos <david@davidgf.net>  Tue, 23 Dec 2014 23:20:00 +0200

pidgin-whatsapp (0.5) quantal; urgency=low

  * Some minor cleanups
  * Removed official WhatsApp logos due to copyright issues

 -- David Guillen Fandos <david@davidgf.net>  Sat, 12 Jul 2014 14:15:00 +0200

pidgin-whatsapp (0.4-2) quantal; urgency=low

  * Many bugfixes
    - Fix for image upload (whenever we upload an image twice)
    - Fix ping parsing, avoids disconnects
    - Fixed a memory leak, this should alleviate memory consumption
  * Some other bugs not affecting Unix-like platforms

 -- David Guillen Fandos <david@davidgf.net>  Mon, 2 Feb 2014 23:40:00 +0200

pidgin-whatsapp (0.4-1) quantal; urgency=low

  * Updated WhatsApp API to the newest version (v1.4)
    - Contact statuses working again
    - Sending images might not work, please check
    - No more update messages from WA server
  * Other small bugs such as profile photo querying...

 -- David Guillen Fandos <david@davidgf.net>  Mon, 28 Jan 2014 00:15:00 +0200

pidgin-whatsapp (0.3-2) quantal; urgency=low

  * Fixed some bugs:
    - Location reception link updated
    - Added video reception support
    - Fixed SIGSEGV on some corner cases
  * Many other small bug fixes and code refactor

 -- David Guillen Fandos <david@davidgf.net>  Mon, 27 Jan 2014 23:40:00 +0200

pidgin-whatsapp (0.3-1) quantal; urgency=low

  * Fixed some bugs in chat groups
    - Images/files are received in the chat windows
    - Buddy names appear in the chat window
    - Notifications are received OK
  * Fixed escaping of HTML/XML characters such as double quotes
  * Adding offline status
  * Error checking for group chats with proper error notifications
  * Initial status fixed: the status set at startup time is used
  * Fixed memory leaks which caused memory starvation
  * Many other small bug fixes and code refactor

 -- David Guillen Fandos <david@davidgf.net>  Tue, 8 Oct 2013 23:20:00 +0200

pidgin-whatsapp (0.2-4) quantal; urgency=low

  * Fixed bug in build Makefile

 -- David Guillen Fandos <david@davidgf.net>  Mon, 14 Sep 2013 23:00:00 +0200

pidgin-whatsapp (0.2-3) quantal; urgency=low

  * Fixed bugs in user status parsing
  * Fixed message (images and files) in group chats

 -- David Guillen Fandos <david@davidgf.net>  Mon, 14 Sep 2013 22:50:00 +0200

pidgin-whatsapp (0.2-2) quantal; urgency=low

  * Fixed Makefile to add DESTDIR (fixes packaging errors)

 -- David Guillen Fandos <david@davidgf.net>  Mon, 26 Aug 2013 17:50:00 +0200

pidgin-whatsapp (0.2-1) quantal; urgency=low

  * Update to v0.2 due to conflicts with packaging

 -- David Guillen Fandos <david@davidgf.net>  Mon, 26 Aug 2013 13:07:00 +0200

pidgin-whatsapp (0.1-1) quantal; urgency=low

  * Update to v0.1 (see github.com/davidgfnet/whatsapp-purple for changes)



=== debian/control ===
Source: pidgin-whatsapp
Section: net
Priority: optional
Maintainer: David Guillen Fandos <david@davidgf.net>
DM-Upload-Allowed: yes
Build-Depends: debhelper (>= 7.0.50), libglib2.0-dev, libpurple-dev, libfreeimage-dev (>= 3.0.0), libprotobuf-dev, protobuf-compiler
Standards-Version: 3.8.4
Homepage: https://github.com/davidgfnet/whatsapp-purple/

Package: pidgin-whatsapp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpurple0 (>= 2.3.0), libfreeimage3, libprotobuf9
Description: WhatsApp plugin for Pidgin
 This is a WhatsApp plugin for Pidgin and libpurple messengers. It connects
 to the WhatsApp servers using the password (which needs to be retrieved
 separately). Only one client can connect at a time (including your phone).
